package com.hzya.frame.plugin.cbs8.plugin;

import cn.hutool.core.date.DateUtil;
import com.alibaba.fastjson.JSONObject;
import com.hzya.frame.base.PluginBaseEntity;
import com.hzya.frame.cbs8.dto.req.TransactionDetailReqDTO;
import com.hzya.frame.cbs8.dto.res.TransactionDetailDTO;
import com.hzya.frame.cbs8.util.CBSUtil;
import com.hzya.frame.plugin.cbs8.service.ICbsPluginService;
import com.hzya.frame.web.entity.JsonResultEntity;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;

import java.util.List;

/**
 * @Description 交易明细查询
 * @Author xiangerlin
 * @Date 2024/6/17 16:03
 **/
public class TransactionDetailPluginInitializer extends PluginBaseEntity {
    Logger logger = LoggerFactory.getLogger(getClass());

    @Autowired
    private ICbsPluginService cbsPluginService;

    /***
     * 插件初始化方法
     * @Author 👻👻👻👻👻👻👻👻 gjh
     * @Date 2023-08-02 10:48
     * @Param []
     * @return void
     **/
    @Override
    public void initialize() {
        logger.info(getPluginLabel() + "執行初始化方法initialize()");
    }

    /****
     * 插件销毁方法
     * @author 👻👻👻👻👻👻👻👻 gjh
     * @date 2023-08-02 10:48
     * @return void
     **/
    @Override
    public void destroy() {
        logger.info(getPluginLabel() + "執行銷毀方法destroy()");
    }

    /****
     * 插件的ID
     * @author 👻👻👻👻👻👻👻👻 gjh
     * @date 2023-08-02 10:48
     * @return void
     **/
    @Override
    public String getPluginId() {
        return "CBS8TransactionDetailQueryPlugin";
    }

    /****
     * 插件的名称
     * @author 👻👻👻👻👻👻👻👻 gjh
     * @date 2023-08-02 10:48
     * @return void
     **/
    @Override
    public String getPluginName() {
        return "cbs8交易明细查询插件";
    }

    /****
     * 插件的显示值
     * @author 👻👻👻👻👻👻👻👻 gjh
     * @date 2023-08-02 10:48
     * @return void
     **/
    @Override
    public String getPluginLabel() {
        return "cbs8交易明细查询插件";
    }

    /***
     * 插件类型 1、场景插件
     * @Author 👻👻👻👻👻👻👻👻 gjh
     * @Date 2023-08-02 14:01
     * @Param []
     * @return java.lang.String
     **/
    @Override
    public String getPluginType() {
        return "1";
    }

    /***
     * 执行业务代码
     * @Author 👻👻👻👻👻👻👻👻 gjh
     * @Date 2023-08-07 11:20
     * @param requestJson  执行业务代码的参数
     * @return void
     **/
    @Override
    public JsonResultEntity executeBusiness(JSONObject requestJson) throws Exception {
        TransactionDetailReqDTO transactionDetailReqDTO = null;
        if (null != requestJson){
            requestJson.remove("jsonStr");
            transactionDetailReqDTO = JSONObject.parseObject(requestJson.toString(),TransactionDetailReqDTO.class);
        }
        if (null == transactionDetailReqDTO){
            transactionDetailReqDTO = new TransactionDetailReqDTO();
        }
        transactionDetailReqDTO.setCurrentPage(CBSUtil.DEFAULT_CURRENT_PAGE);
        transactionDetailReqDTO.setPageSize(CBSUtil.DEFAULT_PAGE_SIZE);
        transactionDetailReqDTO.setStartDate(DateUtil.today());
        transactionDetailReqDTO.setEndDate(DateUtil.today());
        transactionDetailReqDTO.setDateType("0");
        transactionDetailReqDTO.setLoanType("2");
        //1查询交易明细
        List<TransactionDetailDTO> transactionDetailList = cbsPluginService.queryTransactionDetail(transactionDetailReqDTO);
        //保存交易明细到OA底表
        cbsPluginService.saveTransactionDetail(transactionDetailList);
        return new JsonResultEntity("成功",true,transactionDetailList);
        //return null;
    }
}
